// ////////////////////////////////////////////////////////
// Lecture on the CORBA Component Model, summer term 2003
// Assignment 2, Stephan Brumme, 702544
//
// CORBA client that class a remote "reverse" operation 
//

// save and display IOR
#include <iostream>
#include <fstream>

// IDL compiler generated a stub
#include "Aufgabe2.h"
using namespace Aufgabe2;


int main(int argc, char* argv[])
{
	// initialize CORBA and its BOA components
	CORBA::ORB_var orb = CORBA::ORB_init(argc, argv, "mico-local-orb");
	CORBA::BOA_var boa = orb->BOA_init(argc, argv, "mico-local-boa");
	
	// read IOR
	char reference[1000];
	std::ifstream ior("ior.txt");
	ior >> reference;
	ior.close();
	std::cout << reference << std::endl;

	// create and cast the remote object
	CORBA::Object_var obj = orb->string_to_object(reference);
	Server_var remote = Server::_narrow(obj);

	// invoke the "reverse" operation
	std::cout << remote->reverse("Corba Component Model") << std::endl;

	return 0;
}